blob: 1b2d79a060c70590926474bd145e2e6ea7db77dd [file] [log] [blame]
#!/bin/bash
#
# Copyright (C) 2018 The Android Open Source Project
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
function fail() {
echo Build failed: $1 1>&2
exit 1
}
D8=${ANDROID_HOST_OUT}/bin/d8
if [[ ! -x "${D8}" ]]; then
fail "Must have a runnable d8 binary!"
fi
if [[ -z "${ANDROID_BUILD_TOP}" ]]; then
fail "ANDROID_BUILD_TOP is not defined. Try running 'lunch' first."
fi
SCRIPT_PATH=$( cd $(dirname $0) ; pwd -P )
ASM_CLASSPATH="${ANDROID_BUILD_TOP}/prebuilts/misc/common/asm/asm-6.0.jar"
SRC_PATH="${SCRIPT_PATH}/src"
BUILD_PATH="${1:-${SCRIPT_PATH}/classes}"
if [[ ! -d "${BUILD_PATH}" ]]; then
mkdir "$BUILD_PATH" || exit 1
fi
# Build the initial class files.
(cd "${SRC_PATH}" && javac -cp "${ASM_CLASSPATH}" -d "${BUILD_PATH}" Main.java art/*.java art/constmethodhandle/*.java) || fail "javac error"
# Modify the class files using ASM
(cd "${SCRIPT_PATH}" && java -cp "${ASM_CLASSPATH}:${BUILD_PATH}" art.constmethodhandle.TestGenerator "${BUILD_PATH}" "$D8") || fail "generator failure"
# Remove the modification classes. We don't need nor want them for the actual test.
(cd ${BUILD_PATH} && find . -name "TestGenerator*.class" | xargs rm) || fail "Cleanup failure"